
#include "gpio.h"

/********************************************************************************/
void GPIOInit(void)
{
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<6);
}
/********************************************************************************/
void GPIOSetDir( uint8_t portNum, uint8_t bitPosi, uint8_t dir )
{
  if (dir==1)
    LPC_GPIO[portNum]->DIR |= 1<<bitPosi;
  else if (dir==0)
    LPC_GPIO[portNum]->DIR &= ~(1<<bitPosi);
	
  if ((portNum==0)&&(bitPosi==0))  LPC_IOCON->RESET_PIO0_0 = 0x000000D1;
  else if ((portNum==0)&&(bitPosi==4))  LPC_IOCON->PIO0_4  = 0x000001C0;
  else if ((portNum==0)&&(bitPosi==5))  LPC_IOCON->PIO0_5  = 0x000001C0;
  else if ((portNum==0)&&(bitPosi==10)) LPC_IOCON->SWCLK_PIO0_10 = 0x000000D1;
  else if ((portNum==0)&&(bitPosi==11)) LPC_IOCON->R_PIO0_11 = 0x000000D1;
  else if ((portNum==1)&&(bitPosi==0))  LPC_IOCON->R_PIO1_0 = 0x000000D1;
  else if ((portNum==1)&&(bitPosi==1))  LPC_IOCON->R_PIO1_1 = 0x000000D1;
  else if ((portNum==1)&&(bitPosi==2))  LPC_IOCON->R_PIO1_2 = 0x000000D1;
  else if ((portNum==1)&&(bitPosi==3))  LPC_IOCON->SWDIO_PIO1_3 = 0x000000D1;
}
/********************************************************************************/
void GPIOSetValue( uint8_t portNum, uint8_t bitPosi, uint8_t bitVal )
{
  if (bitVal==1)
    LPC_GPIO[portNum]->MASKED_ACCESS[0xfff] |= 1<<bitPosi;
  else if (bitVal==0)
    LPC_GPIO[portNum]->MASKED_ACCESS[0xfff] &= ~(1<<bitPosi);
}
/********************************************************************************/
uint8_t GPIOGetValue( uint8_t portNum, uint8_t bitPosi )
{
  return ((LPC_GPIO[portNum]->MASKED_ACCESS[0xfff])>>bitPosi)&0x01;
}
/********************************************************************************/

/********************************************************************************/
